<script lang="ts">
import Vue from 'vue';

export default Vue.extend({
  name: 'StatsTimeline',
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
  },
});
</script>

<template>
  <section class="stats-timeline" data-darkmode="true">
    <SlpRow class="stats-timeline__header">
      <SlpTypography variant="heading2-bold" tag="h2" class="header">{{
        data.stats_timeline.header
      }}</SlpTypography>
      <SlpButton
        v-if="data.stats_timeline.cta.href"
        :href="data.stats_timeline.cta.href"
        variant="tertiary"
        class="slp-mt-24 cta-button"
        :aria-label="data.stats_timeline.cta.data_ga_name"
        :data-ga-name="data.stats_timeline.cta.data_ga_name"
        :data-ga-location="data.stats_timeline.cta.data_ga_location"
        >{{ data.stats_timeline.cta.text }}
        <SlpIcon name="chevron-lg-right" variant="product" />
      </SlpButton>
    </SlpRow>
    <SlpRow class="stats-timeline__row">
      <SlpColumn
        v-for="(stat, index) in data.stats_timeline.stats"
        :key="index"
        :cols="3"
        class="stats-timeline__column"
      >
        <div class="stats-timeline__stat">
          <div class="stats-timeline__stat-circle">
            <SlpIcon
              v-if="stat.icon"
              :name="stat.icon"
              variant="marketing"
              :alt="stat.icon"
              size="md"
              class="stats-timeline__stat-icon"
            />
          </div>
          <div class="stats-timeline__stat-type">
            <SlpTypography
              variant="heading2-bold"
              tag="h3"
              class="stats-timeline__stat-number slp-mt-24"
              >{{ stat.stat }}</SlpTypography
            >
            <SlpTypography
              variant="base"
              tag="p"
              class="stats-timeline__stat-text"
              >{{ stat.text }}</SlpTypography
            >
          </div>
        </div>
      </SlpColumn>
    </SlpRow>
  </section>
</template>

<style scoped lang="scss">
.stats-timeline {
  padding: $spacing-96 0;
  position: relative;
  background-color: $color-surface-700;
  color: $color-text-50;
  .header {
    width: 60%;
    @media (max-width: $breakpoint-lg) {
      width: 100%;
    }
  }

  &__header {
    color: $color-text-50;
    width: 100%;
    display: flex;
    flex-direction: row;
    justify-content: space-between;
    align-items: flex-end;
    margin-bottom: 48px;
    @media (max-width: $breakpoint-lg) {
      flex-wrap: wrap;
    }

    .cta-button {
      color: $color-text-50;
    }
  }

  &:after {
    background: $color-surface-700;
    content: '';
    left: -50vw;
    height: 100%;
    position: absolute;
    top: 0;
    width: 200vw;
    z-index: -1;
  }

  &__row {
    justify-content: space-between;
  }

  &__column {
    padding: 0 $spacing-32;
    display: flex;
    flex-direction: column;
    justify-content: space-between;
    text-align: center;
    max-width: 230px;
  }

  &__column:first-of-type {
    padding-left: 0;
  }

  &__column:last-of-type {
    padding-right: 0;
  }

  &__stat-circle {
    padding: 36px;
    width: 48px;
    height: 48px;
    background: #7759c2;
    border-radius: 100%;
    position: relative;
    margin: 0 auto;
    z-index: 2;

    @media (min-width: $breakpoint-lg) {
      &:after {
        background: white;
        content: '';
        left: 100%;
        height: 1px;
        position: absolute;
        top: 50%;
        width: 200px;
        z-index: -1;
      }
    }
  }

  &__column:nth-child(4) .stats-timeline__stat-circle {
    &:after {
      display: none;
    }
  }

  &__stat-icon {
    position: absolute;
    top: 50%;
    left: 50%;
    transform: translate(-50%, -50%);
  }

  @media (max-width: $breakpoint-lg) {
    &__column {
      padding: $spacing-32 0;
      text-align: left;
      max-width: unset;
    }

    &__stat-circle {
      margin: unset;

      &:after {
        background: white;
        content: '';
        left: 50%;
        height: 150px;
        position: absolute;
        top: 100%;
        width: 1px;
        z-index: -1;
      }
    }

    &__stat {
      display: flex;
    }

    &__stat-number {
      margin-top: 0;
    }

    &__stat-type {
      margin-left: $spacing-16;
    }
  }
}
</style>
